import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, continuedIndent, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { ifNotIn, completeFromList } from '@codemirror/autocomplete';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_identifier = {__proto__:null,permit:18, forbid:20, principal:132, is:28, in:38, action:138, resource:146, when:56, unless:58, true:62, false:62, has:78, like:80, if:82, then:84, else:86, contains:88, containsAll:90, context:222};
const parser = LRParser.deserialize({
  version: 14,
  states: "6OQYQPOOOOQO'#C`'#C`OeQPO'#DjOOQO'#D`'#D`OYQPO'#C_OjQPO'#C_QYQPOOOOQO'#Dm'#DmOOQO'#D_'#D_OOQO'#Ca'#CaOoQPO,5:UOOQO-E7^-E7^OtQPO,58yOyQPO,58yOOQO-E7]-E7]O!OQPO1G/pOyQPO1G.eOOQO'#Ci'#CiO!TQPO'#DoOOQO'#Ch'#ChO!cQPO'#DnOOQO'#Cg'#CgO!hQPO1G.eO!mQPO7+%[O!rQPO7+$POOQO'#Cm'#CmO!wQPO,5:ZO#PQPO'#DxO!wQPO,5:ZOOQO,5:Z,5:ZO#UQPO,5:YO#ZQPO7+$POOQO<<Hv<<HvO#fQPO<<GkO#qQPO'#CkOOQO'#Da'#DaO#vQPO,5:eOOQO1G/u1G/uO$OQPO,5:dO$TQPO,5:fOOQO'#Cr'#CrO$]QPO'#DrOOQO'#Cq'#CqO$hQPO1G/tOOQO'#Dc'#DcO#fQPO<<GkOOQO<<Gk<<GkO$mQPO'#CwO$rQPOAN=VOOQOAN=VAN=VOOQO,59V,59VOOQO-E7_-E7_OOQO1G0P1G0PO$}QPO1G0OOOQO1G0Q1G0QO#PQPO'#DyO%YQPO,5:^OOQO,5:^,5:^O%bQPO7+%`OOQO-E7a-E7aO%gQPO,59cOOQOG22qG22qO#PQPO'#DtOOQO1G/x1G/xOOQO'#Cv'#CvO&eQPO'#DvOOQO'#Cu'#CuOOQO<<Hz<<HzO&sQPO'#D|O&{QPO'#DtOOQO'#D}'#D}OOQO'#EO'#EOO(eQQO1G.}O%gQPO'#E^O(lQPO'#EkOOQO'#D]'#D]OOQO'#D|'#D|O(tQPO'#EeO(yQPO'#DuO)RQPO,5:`OOQO,5:b,5:bO)WQPO,5:bO)WQPO,5:bO)`QPO,5;SOOQO,5:h,5:hO)hQPO'#EjO)pQPO,5;TOOQO'#C}'#C}OOQO'#DO'#DOOOQO'#DP'#DPOOQO'#DQ'#DQOOQO'#DR'#DRO%gQPO,5:mO%gQPO,5:mO%gQPO,5:mO%gQPO,5:mO%gQPO,5:mO%gQPO,5:wO)uQPO,5:yO%gQPO,5:|O*QQPO,5:zO#PQPO,5:{O*YQPO,5;OOOQO7+$i7+$iO*_QQO,5:xO*fQQO'#EmO*kQPO'#ElO*sQPO,5;VO*xQPO,5;PO*}QPO,5:aOOQO1G/z1G/zOOQO1G/|1G/|O%gQPO1G0nO+VQPO'#DeO+bQPO,5;UOOQO1G0o1G0oOOQO1G0X1G0XO,zQQO1G0XO-UQQO1G0XO.sQQO1G0XO.zQQO1G0XO/RQQO1G0cOOQO1G0e1G0eO/YQPO1G0lO/_QPO1G0mO/dQQO'#EcO/nQPO1G0hOOQO1G0f1G0fO/sQPO1G0gOOQO1G0j1G0jOOQO1G0d1G0dO+VQPO,5;XO(lQPO'#DfO/xQPO,5;WOOQO1G0q1G0qOOQO1G0k1G0kO0QQPO1G/{O#PQPO'#DbO0YQPO7+&YOOQO,5:P,5:POOQO-E7c-E7cOOQO7+%}7+%}O%gQPO7+&WO%gQPO7+&XO%gQPO'#DdO0_QPO,5:}OOQO7+&S7+&SO0gQSO7+&ROOQO1G0s1G0sOOQO,5:Q,5:QOOQO-E7d-E7dOOQO-E7`-E7`O2QQPO,59|OOQO<<It<<ItO2YQQO<<IrO2aQQO<<IsO2hQQO,5:OOOQO-E7b-E7bOOQO1G/h1G/hOOQOAN?^AN?^OOQOAN?_AN?_",
  stateData: "2r~O!]OSPOS~OXVOYVO!_PO~O!`XO~OU]O~OU_O~OU`O~O!daO~OVgO~O^kObiOclOd!cX~OdnO~OWoO~OWpO~OWqO~O!`rO!euO~O!`rO~O!gxO~Ol!POm!PO!Q!OO~Ol!POm!PO!Q!RO~O`!SO~OV!UO!`rO~O!`!VO~OV!WO!`rO~ObiOc!YOd!fX~Od![O~On!^O~Ol!POm!PO!Q!_O~O`!SOd!liW!li~Og!`O!`rO~O!k!bO~OU!kOV!hOg!gOn!lOo!hOp!hOy!oO!`rO!daO!gxO!k!bO!s!iO!t!iO#c!mO~O^kObiOc!tOW!jX~OV!vO!`!uO~OV!hOo!hOp!hO!`rO~OU#VO^#XOb!{Oc#QOg#TOv#UOw#WOx#YO!s!zO!v!yO!w!zO!x!{O!y!{O!z!{O!{!{O!|!{O!}!|O#O!}O~O!O#ZO~P'ZOV#]O!`#]O~Oz#`O~OV#aO!`rO~Oh#bO~O!`rO!o#cO~OU#dO`!SO~Od#eOh#^X~Oh#gO~O|#oO}#pO!`#nO~OV#sO!`#sO~OV#uO~OW#vO~P'ZO#b#wO~Od#xO!O#`X~O!O#zO~O{#{O~Od#}Oh!ia~OV!hOo!hOp!hO~Od#eOh#^a~O!v!yOU!ui^!uib!uic!uig!uiv!uiw!uix!ui!O!ui!x!ui!y!ui!z!ui!{!ui!|!ui!}!ui#O!uiW!uih!uid!ui~O!s!ui!w!ui~P+jO!s!zO!w!zO~P+jOb!{Oc#QO!s!zO!v!yO!w!zO!x!{O!y!{O!z!{O!{!{O!|!{OU!ui^!uig!uiv!uiw!uix!ui!O!ui#O!uiW!uih!uid!ui~O!}!ui~P-`O!}!|O~P-`Oh$RO~P'ZOU$SO~OU$TO~Od$UOW#VX~P'ZOW$WO~O!`$XO~Od#xO!O#`a~Od#}Oh!ii~OW$_O~Od$UOW#Va~O`!SOU#Tq^#Tqb#Tqc#Tqg#Tqv#Tqw#Tqx#Tq!O#Tq!s#Tq!v#Tq!w#Tq!x#Tq!y#Tq!z#Tq!{#Tq!|#Tq!}#Tq#O#TqW#Tqh#Tqd#Tq~OV$dO!`rO~OW$eO~P'ZOW$fO~P'ZOW!Wad!Wa~P'ZO",
  goto: ",k#bPPP#c#g#lPPPPP#o#u#yP$^P%PPPP%Y%]PP%o%r&UPPPPP&[&i&u'Q'[PPPPPPPPP#}P'e'k'r(s(y)T)Z)aPPP)gPP)l)s)wPP){P*O*b*fP*i*o*oP*x+o#}PP#}PPPPPPPPP#}#}#}#}#}#},X#}#}#}#}#}#},_#},b,eTWOUVQOSURYQQf]Rh`Td]`Sb]`k!n!^!k#O#P#Q#R#S#T#V#d$S$T$U!asjkltvw!X!Y!^!`!f!g!k!p!s!t#O#P#Q#R#S#T#V#X#d#t#}$S$T$U$^QjbQ!XyR!s!cR{nQynk!n!^!k#O#P#Q#R#S#T#V#d$S$T$UR!e![Q!c![k!n!^!k#O#P#Q#R#S#T#V#d$S$T$UX|oq}!Qg#O!j#[#i#j#k#l#m#q$`$a$be#P!j#[#j#k#l#m#q$`$a$bc#Q!j#[#k#l#m#q$`$a$ba#R!j#[#l#m#q$`$a$b_#S!j#[#m#q$`$a$bQUOR^USSOURZSUtj!X!sQvkUwl!Y!t^!Ttvw!f!p#t$^j!f!^!k#O#P#Q#R#S#T#V#d$S$T$US!p!`!gQ#t#XR$^#}Q#|#aR$]#|Q}oQ!QqT!]}!QQ$V#qR$c$VQ#f!wR$Q#fQ#y#^R$[#yVROSUSTOUR[STe]`Tc]`RznQ!a!Yk!n!^!k#O#P#Q#R#S#T#V#d$S$T$UT!q!`!gR!d![QmbR!r!cQmbQ!ZyR!r!cQ!j!^Q#[!kQ#h#OQ#i#PQ#j#QQ#k#RQ#l#SQ#m#TS#q#V#dQ$`$SQ$a$TR$b$Uj!n!^!k#O#P#Q#R#S#T#V#d$S$T$UQ!w!gQ$P#eR$Y#wQ#r#VR$O#dR!x!gR#_!lQ#^!lR$Z#x",
  nodeNames: "⚠ LineComment Program Policy At AnnotationKey ( String ) permit forbid Scope PrincipalConstraint Principal is Namespace :: CompareOp == in , ActionConstraint Action [ ] ResourceConstraint Resource Condition when unless { BooleanLiteral Int ArithOp ArithOp CompareOp LogicOp LogicOp . has like if then else contains containsAll } Context ;",
  maxTerm: 111,
  nodeProps: [
    ["isolate", 1,""]
  ],
  skippedNodes: [0,1],
  repeatNodeCount: 8,
  tokenData: ",h~RsXY#`YZ#`]^#`pq#`qr#qrs$Otu%lvw&axy&lyz&qz{&v{|&{|}'Q}!O'V!O!P'[!P!Q'a!Q![(O![!](W!]!^(e!^!_(j!_!`(w!`!a)S!a!b)a!b!c+r!c!}%l!}#O+w#P#Q+|#R#S%l#T#o%l#o#p,R#p#q,W#q#r,c$g;'S%l;'S;=`&Z<%lO%l~#eS!]~XY#`YZ#`]^#`pq#`V#vP!tP!_!`#yU$OO!|U~$RVOr$Ors$hs#O$O#O#P$m#P;'S$O;'S;=`%f<%lO$O~$mOV~~$pRO;'S$O;'S;=`$y;=`O$O~$|WOr$Ors$hs#O$O#O#P$m#P;'S$O;'S;=`%f;=`<%l$O<%lO$O~%iP;=`<%l$O~%qW!`~tu%l!Q![%l!c!}%l#R#S%l#T#o%l$g;'S%l;'S;=`&Z<%lO%l~&^P;=`<%l%l~&dPvw&g~&lO!}~~&qOU~~&vOW~~&{O!v~~'QO!w~~'VOd~~'[O!s~~'aOv~~'dP!P!Q'g~'lSP~OY'gZ;'S'g;'S;=`'x<%lO'g~'{P;=`<%l'g~(TPp~!Q![(OV(]P#bQ![!](`T(eO`T~(jO!Q~~(oP!x~!_!`(r~(wO!y~~(zP!_!`(}~)SOb~~)XP!{~!_!`)[~)aO!z~~)dQ#d#e)j#f#g*q~)mP#f#g)p~)sP#]#^)v~)yP#b#c)|~*PP#V#W*S~*VP#]#^*Y~*]P#d#e*`~*cP#T#U*f~*iP#`#a*l~*qO!e~~*tP#X#Y*w~*zP#g#h*}~+QP#c#d+T~+WP#i#j+Z~+^P#f#g+a~+dP#V#W+g~+jP#X#Y+m~+rO!o~~+wO!_~~+|Og~~,ROh~~,WOn~~,ZP#p#q,^~,cO#O~~,hO!O~",
  tokenizers: [0, 1, 2],
  topRules: {"Program":[0,2]},
  specialized: [{term: 62, get: (value) => spec_identifier[value] || -1}],
  tokenPrec: 0
});

let kwCompletion = (name) => ({ label: name, type: "keyword" });
const keywords = "permit forbid when unless".split(" ").map(kwCompletion);
const dontComplete = ["String", "LineComment"];
const cedarLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Policy: continuedIndent(),
                Condition: continuedIndent(),
                Application: delimitedIndent({ closing: ")", align: false }),
            }),
            foldNodeProp.add({
                Application: foldInside,
            }),
            styleTags({
                Effect: tags.definitionKeyword,
                "permit forbid": tags.definitionKeyword,
                "when unless": tags.keyword,
                "in is has contains containsAll": tags.operatorKeyword,
                "if then else": tags.controlKeyword,
                Identifier: tags.variableName,
                CompareOp: tags.compareOperator,
                BooleanLiteral: tags.bool,
                Principal: tags.variableName,
                Action: tags.variableName,
                Resource: tags.variableName,
                Context: tags.variableName,
                String: tags.string,
                Int: tags.integer,
                LineComment: tags.lineComment,
                At: tags.meta,
                AnnotationKey: tags.meta,
                "( )": tags.paren,
                "{ }": tags.brace,
                "[ ]": tags.squareBracket,
                ";": tags.separator,
            }),
        ],
    }),
    languageData: {
        commentTokens: { line: "//" },
    },
});
function cedar() {
    return new LanguageSupport(cedarLanguage, [
        cedarLanguage.data.of({
            autocomplete: ifNotIn(dontComplete, completeFromList(keywords)),
        }),
    ]);
}

export { cedar, cedarLanguage };
